/*
 * @Date: 2021-12-08 15:59:46
 * @LastEditors: JinxuChen
 * @LastEditTime: 2022-01-11 14:25:43
 * @FilePath: \GpsCardAdmin\src\utils\request.js
 * @description:
 */
import axios from 'axios'
import { Message } from 'element-ui'
import store from '@/store'
/* import { getToken } from '@/utils/auth' */

// create an axios instance
const service = axios.create({
  baseURL: process.env.VUE_APP_BASE_API, // url = base url + request url
  // withCredentials: true, // send cookies when cross-domain requests
  /* timeout: 5000  */// request timeout
})

// request interceptor
service.interceptors.request.use(
  config => {
    // do something before request is sent

    if (store.getters.token) {
      // let each request carry token
      // ['X-Token'] is a custom headers key
      // please modify it according to the actual situation
      config.headers['AuthToken'] = store.getters.token;
    }
    return config
  },
  error => {
    // do something with request error
    console.log(error) // for debug
    return Promise.reject(error)
  }
)

// response interceptor
service.interceptors.response.use(
  /**
   * If you want to get http information such as headers or status
   * Please return  response => response
  */

  /**
   * Determine the request status by custom code
   * Here is just an example
   * You can also judge the status by HTTP Status Code
   */
  response => {
    const res = response.data

    // if the custom code is not 20000, it is judged as an error.
    if (res.code !== 0) {
      Message({
        message: res.message || '出错了,请联系管理员！',
        type: 'error',
        duration: 3 * 1000
      })
      // 106 token验证过期;
      return Promise.reject(new Error(res.message))
    } else if (res.code === 106) {
        // to re-login
        setTimeout(() => {
            store.dispatch('user/resetToken').then(() => {
                Message({
                    message: 'token过期,请重新登录',
                    type: 'error',
                    duration: 1500
                  })
                location.reload()
            })
        }, 1500)
        return Promise.reject(new Error('token过期,请重新登录'))
    }
    else {
      return res
    }
  },
  error => {
    console.log('err' + error) // for debug
    Message({
      message: error.message,
      type: 'error',
      duration: 3 * 1000
    })
    /* return Promise.reject(error) */
  }
)

export default service
